local AceGUI = LibStub("AceGUI-3.0")
local raiders
local nameFilter = ""
local classFilter = {}
local sortbypoints = true

local function SetStatus(msg)
	if DERR.MainWindow ~= nil then
		DERR.MainWindow:SetStatusText(msg)
	end
end

function DEDKP_MainWindow_Init()
	raiders = {}
	nameFilter = ""
	classFilter = {}
end

function DEDKP_MainWindow_Show()
	DEDKP_MainWindow_Init()

	DERR.MainWindow = AceGUI:Create("Frame")
	DERR.MainWindow:SetTitle("Draconis Erus Raid Recorder")
	DERR.MainWindow:SetLayout("Flow")
	DERR.MainWindow:SetWidth(565)
	DERR.MainWindow:SetHeight(450)
	DERR.MainWindow:EnableResize(false)
	DERR.MainWindow:SetCallback("OnClose", DEDKP_MainWindow_OnClose)

	--Guild Scroll
	DERR.MainWindow.GuildContainer = AceGUI:Create("InlineGroup")
	DERR.MainWindow.GuildContainer:SetLayout("Fill")
	DERR.MainWindow.GuildContainer:SetWidth(165)
	DERR.MainWindow.GuildContainer:SetHeight(300)
	DERR.MainWindow.GuildContainer:SetTitle("Guild List:")
	DERR.MainWindow:AddChild(DERR.MainWindow.GuildContainer)

	DERR.MainWindow.GuildScroll = AceGUI:Create("ScrollFrame")
	DERR.MainWindow.GuildScroll:SetLayout("Flow")
	DERR.MainWindow.GuildContainer:AddChild(DERR.MainWindow.GuildScroll)

	--Wait List Scroll
	DERR.MainWindow.StandByContainer = AceGUI:Create("InlineGroup")
	DERR.MainWindow.StandByContainer:SetLayout("Fill")
	DERR.MainWindow.StandByContainer:SetWidth(165)
	DERR.MainWindow.StandByContainer:SetHeight(300)
	DERR.MainWindow.StandByContainer:SetTitle("Wait List:")
	DERR.MainWindow:AddChild(DERR.MainWindow.StandByContainer)

	DERR.MainWindow.StandByScroll = AceGUI:Create("ScrollFrame")
	DERR.MainWindow.StandByScroll:SetLayout("Flow")
	DERR.MainWindow.StandByContainer:AddChild(DERR.MainWindow.StandByScroll)

	--Controls
	DERR.MainWindow.LogoContainer = AceGUI:Create("InlineGroup")
	DERR.MainWindow.LogoContainer:SetLayout("DERR_Layout")
	DERR.MainWindow.LogoContainer:SetWidth(200)
	DERR.MainWindow.LogoContainer:SetHeight(300)
	DERR.MainWindow.LogoContainer:SetTitle("Version: "..DERR_VERSION)
	DERR.MainWindow:AddChild(DERR.MainWindow.LogoContainer)


	DERR.MainWindow.Loot = AceGUI:Create("CheckBox")
	DERR.MainWindow.Loot:SetLabel("Loot Raid")
	DERR.MainWindow.Loot:SetWidth(90)
	DERR.MainWindow.LogoContainer:AddChild(DERR.MainWindow.Loot)

	DERR.MainWindow.StartRaid = AceGUI:Create("Button")
	DERR.MainWindow.StartRaid:SetWidth(120)
	DERR.MainWindow.StartRaid:SetHeight(40)
	DERR.MainWindow.StartRaid:SetText("Start Raid")
	DERR.MainWindow.StartRaid:SetCallback("OnClick",DEDKP_MainWindow_StartRaid_OnClick)
	
	DERR.MainWindow.LogoContainer:AddChild(DERR.MainWindow.StartRaid)

	DERR.MainWindow.EndRaid = AceGUI:Create("Button")
	DERR.MainWindow.EndRaid:SetWidth(120)
	DERR.MainWindow.EndRaid:SetHeight(40)
	DERR.MainWindow.EndRaid:SetText("End Raid")
	DERR.MainWindow.EndRaid:SetCallback("OnClick",DEDKP_MainWindow_EndRaid_OnClick)
	DERR.MainWindow.LogoContainer:AddChild(DERR.MainWindow.EndRaid)

	DERR.MainWindow.LogoContainer:AddChild(AceGUI:Create("Label"))

	DERR.MainWindow.BidManager = AceGUI:Create("Button")
	DERR.MainWindow.BidManager:SetWidth(120)
	DERR.MainWindow.BidManager:SetHeight(40)
	DERR.MainWindow.BidManager:SetText("Bid Manager")
	DERR.MainWindow.BidManager:SetCallback("OnClick",DEDKP_MainWindow_BidManager_OnClick)
	DERR.MainWindow.LogoContainer:AddChild(DERR.MainWindow.BidManager)

	DERR.MainWindow.LootManager = AceGUI:Create("Button")
	DERR.MainWindow.LootManager:SetWidth(120)
	DERR.MainWindow.LootManager:SetHeight(40)
	DERR.MainWindow.LootManager:SetText("Loot Manager")
	DERR.MainWindow.LootManager:SetCallback("OnClick",DEDKP_MainWindow_LootManager_OnClick)
	DERR.MainWindow.LogoContainer:AddChild(DERR.MainWindow.LootManager)

	DERR.MainWindow.LogoContainer:AddChild(AceGUI:Create("Label"))

	DERR.MainWindow.ImportButton = AceGUI:Create("Button")
	DERR.MainWindow.ImportButton:SetWidth(120)
	DERR.MainWindow.ImportButton:SetHeight(20)
	DERR.MainWindow.ImportButton:SetText("Import Points")
	DERR.MainWindow.ImportButton:SetCallback("OnClick",DEDKP_MainWindow_ImportButton_OnClick)
	DERR.MainWindow.LogoContainer:AddChild(DERR.MainWindow.ImportButton)

	DERR.MainWindow.VersionButton = AceGUI:Create("Button")
	DERR.MainWindow.VersionButton:SetText("Versions")
	DERR.MainWindow.VersionButton:SetWidth(120)
	DERR.MainWindow.VersionButton:SetHeight(20)
	DERR.MainWindow.VersionButton:SetCallback("OnClick",DEDKP_VersionWindow_VersionButton_OnClick)
	DERR.MainWindow.LogoContainer:AddChild(DERR.MainWindow.VersionButton)

	DERR.MainWindow.FilterGroup = AceGUI:Create("SimpleGroup")
	DERR.MainWindow.FilterGroup:SetWidth(165)
	DERR.MainWindow:AddChild(DERR.MainWindow.FilterGroup)

	DERR.MainWindow.Sort = AceGUI:Create("Button")
	DERR.MainWindow.Sort:SetText("Sort")
	DERR.MainWindow.Sort:SetWidth(165)
	DERR.MainWindow.Sort:SetHeight(20)
	DERR.MainWindow.Sort:SetCallback("OnClick",DEDKP_MainWindow_Sort_OnClick)
	DERR.MainWindow.FilterGroup:AddChild(DERR.MainWindow.Sort)

	DERR.MainWindow.Filter = AceGUI:Create("EditBox")
	DERR.MainWindow.Filter:SetWidth(165)
	DERR.MainWindow.Filter:SetCallback("OnTextChanged",DEDKP_Filter_OnTextChanged)
	DERR.MainWindow.Filter:DisableButton(true)
	DERR.MainWindow.FilterGroup:AddChild(DERR.MainWindow.Filter)

	DERR.MainWindow.Class = AceGUI:Create("Dropdown")
	DERR.MainWindow.Class:SetWidth(165)
	DERR.MainWindow.Class:SetList(dedkp_class_list)
	DERR.MainWindow.Class:SetMultiselect(true)
	DERR.MainWindow.Class:SetValue(0)
	DERR.MainWindow.Class:SetCallback("OnValueChanged",DEDKP_Class_OnValueChanged)
	DERR.MainWindow.FilterGroup:AddChild(DERR.MainWindow.Class)

	DERR.MainWindow.LogoGroup = AceGUI:Create("SimpleGroup")
	DERR.MainWindow.LogoGroup:SetWidth(365)
	DERR.MainWindow.LogoGroup:SetHeight(72)
	DERR.MainWindow.LogoGroup:SetLayout("DERR_Center_Layout")
	DERR.MainWindow:AddChild(DERR.MainWindow.LogoGroup)

	DERR.MainWindow.Logo = AceGUI:Create("Icon")
	DERR.MainWindow.Logo:SetImage("Interface\\AddOns\\DraconisErusRaidRecorder\\Textures\\DraconisErusLogo")
	DERR.MainWindow.Logo:SetImageSize(256,64)
	DERR.MainWindow.Logo:SetCallback("OnClick",DEDKP_MainWindow_Logo_OnClick)
	DERR.MainWindow.LogoGroup:AddChild(DERR.MainWindow.Logo)

	if next(DEDKPPoints[DERR_REALM][DERR_GUILD]) == nil then
		DEDKPPoints[DERR_REALM][DERR_GUILD] = DraconisErus_Guild_GetEmptyPoints()
	end
	
	DEDKP_MainWindow_LoadGuild()
	DEDKP_MainWindow_LoadStandBy()
	DEDKP_MainWindow_SetControls()

	DraconisErus_SetWindowPosition("MainWindow", DERR.MainWindow)

end

function DEDKP_MainWindow_BidManager_OnClick()
	if DERR.BidManager == nil and not DERR_INBID then
		if UnitIsGroupAssistant("player") or UnitIsGroupLeader("player") then
			DEDKP_BidManager_Show()
		else
			DraconisErusRaidRecorder:Print("|cFFFF0000You must have raid assist to handle bidding.|r")
		end
	elseif DERR_INBID then
		DraconisErusRaidRecorder:Print("Bidding in progress.")
	end
end

function DEDKP_MainWindow_LootManager_OnClick()
	if UnitIsGroupAssistant("player") or UnitIsGroupLeader("player") then
		DEDKP_LootManager_Show()
	else
		DraconisErusRaidRecorder:Print("|cFFFF0000You must have raid assist to handle loot.|r")
	end
end


function DEDKP_VersionWindow_VersionButton_OnClick()
	if DERR.VersionWindow == nil then
		DEDKP_VersionWindow_Show()
	end
end

function DEDKP_MainWindow_Logo_OnClick()
	local link = "https://www.draconiserus.com"
	StaticPopupDialogs["DRACONISERUS_SHOW_URL"].urltext = link
	StaticPopup_Show("DRACONISERUS_SHOW_URL", link)
end

function DEDKP_MainWindow_Discord_OnClick()
	local link = "https://discord.gg/ejw6e5U"
	StaticPopupDialogs["DRACONISERUS_DISCORD_SHOW_URL"].urltext = link
	StaticPopup_Show("DRACONISERUS_DISCORD_SHOW_URL", link)
end

function DEDKP_MainWindow_StartRaid_OnClick()
	if not DEDKPSettings["RaidStarted"] then
		DraconisErus_RaidEvent_StartRaid(nil,DERR.MainWindow.Loot:GetValue())
	else
		DraconisErusRaidRecorder:Print("Raid already started.")
	end
end

function DEDKP_MainWindow_EndRaid_OnClick()
	if DEDKPSettings["RaidStarted"] then
		StaticPopup_Show("DRACONISERUS_DEDKP_ENDRAID")
	else
		DraconisErusRaidRecorder:Print("No raid started.")
	end
end

function DEDKP_MainWindow_GuildEntry_OnClick(button)
	if IsInRaid() then
		if DraconisErus_Guild_IsOfficer(DERR_PLAYER) then
			DraconisErus_Queue_Add(button.player)
		end
	else
		DraconisErusRaidRecorder:Print("You must be in a raid to add players to the wait list.")
	end
end

function DEDKP_MainWindow_StandByEntry_OnClick(button)
	if DraconisErus_Guild_IsOfficer(DERR_PLAYER) then
		DraconisErus_Queue_Remove(button.player)
	end
end

function DEDKP_MainWindow_Sort_OnClick(button)
	sortbypoints = not sortbypoints
	DEDKP_MainWindow_LoadGuild()
end

function DEDKP_MainWindow_ImportButton_OnClick(button)
	if DERR.ImportWindow == nil then
		DEDKP_ImportWindow_Show()
	end
end

function DEDKP_MainWindow_AddGuildEntry(player, class, points)
	local g = AceGUI:Create("SimpleGroup")
	g:SetLayout("Flow")

	local il = AceGUI:Create("InteractiveLabel")
	il:SetText(player)
	il:SetHighlight("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	il:SetWidth(90)
	il.player = player
	il:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	il:SetCallback("OnClick",DEDKP_MainWindow_GuildEntry_OnClick)
	g:AddChild(il)


	local l = AceGUI:Create("Label")
	il.points = points
	l:SetText(tostring(points))
	l:SetWidth(25)
	l:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	l:SetJustifyH("RIGHT")
	g:AddChild(l)

	DERR.MainWindow.GuildScroll:AddChild(g)

end

function DEDKP_MainWindow_AddStandByEntry(player,class)
	local il = AceGUI:Create("InteractiveLabel")
	il:SetText(player)
	il:SetHighlight("Interface\\QuestFrame\\UI-QuestTitleHighlight")
	il.player = player
	il:SetColor(dedkp_class_info[class].r,dedkp_class_info[class].g,dedkp_class_info[class].b)
	il:SetCallback("OnClick",DEDKP_MainWindow_StandByEntry_OnClick)
	DERR.MainWindow.StandByScroll:AddChild(il)
end

function DEDKP_MainWindow_LoadGuild()
	raiders = DraconisErus_Guild_GetRaiders()

	if nameFilter == nil then nameFilter = "" end
	nameFilter = strtrim(nameFilter)
	if classFilter == nil then classFilter = "" end

	if sortbypoints then
		DraconisErus_SortRaidersByPoints(raiders)
	else
		DraconisErus_SortRaidersByName(raiders)
	end		

	DERR.MainWindow.GuildScroll:ReleaseChildren()
	for index, value in pairs(raiders) do
		local localClass = dedkp_class_info[value.class].localName
		if nameFilter == "" and next(classFilter) == nil then	--No filter
			DEDKP_MainWindow_AddGuildEntry(value.name, value.class, value.points)
		elseif nameFilter ~= "" and next(classFilter) == nil then	--Name filter
			if string.find(string.upper(value.name),string.upper(nameFilter)) ~= nil then
				DEDKP_MainWindow_AddGuildEntry(value.name, value.class, value.points)
			end
		elseif nameFilter == "" and DraconisErus_TableSearch(classFilter, localClass) > 0 then	--Class filter
			DEDKP_MainWindow_AddGuildEntry(value.name, value.class, value.points)
		else	--Name and Class filter
			if string.find(string.upper(value.name),string.upper(nameFilter)) ~= nil and  DraconisErus_TableSearch(classFilter, localClass) > 0 then
				DEDKP_MainWindow_AddGuildEntry(value.name, value.class, value.points)
			end
		end
	end
end

function DEDKP_MainWindow_LoadStandBy()
	raiders = DraconisErus_Guild_GetRaiders()
	DERR.MainWindow.StandByScroll:ReleaseChildren()
	for _, player in pairs(DEDKPSettings["RaidQueue"]) do
		for index, value in pairs(raiders) do
			if value.name == player then
				DEDKP_MainWindow_AddStandByEntry(player,value.class)
				break
			end
		end
	end
end

function DEDKP_MainWindow_SetControls()
	DERR.MainWindow.Loot:SetDisabled(true)
	DERR.MainWindow.StartRaid:SetDisabled(true)
	DERR.MainWindow.EndRaid:SetDisabled(true)
	DERR.MainWindow.BidManager:SetDisabled(true)
	DERR.MainWindow.LootManager:SetDisabled(true)
	DERR.MainWindow.Loot:SetValue(false)
	DERR.MainWindow.ImportButton:SetDisabled(true)

	SetStatus("")

	if DERR_OUT_OF_DATE then
		SetStatus("|cffff0000Draconis Erus Raid Recorder is out-of-date.|r")
		if not DEDKPSettings["RaidStarted"] then
			return
		end
	end

	if IsInRaid() then
		if DraconisErus_Raid_GetLeader() == DERR_PLAYER then
			if DEDKPSettings["RaidStarted"] then
				SetStatus("Raid in progress.")
				if DEDKPSettings["LootRaid"] then
					DERR.MainWindow.Loot:SetValue(true)
				end
				DERR.MainWindow.EndRaid:SetDisabled(false)
			else
				SetStatus("Ready to start raid.")
				DERR.MainWindow.StartRaid:SetDisabled(false)
				DERR.MainWindow.Loot:SetDisabled(false)
				DERR.MainWindow.ImportButton:SetDisabled(false)

			end
		else
			if DEDKPSettings["RaidStarted"] then
				SetStatus("Raid in progress.")
			else
				DERR.MainWindow.ImportButton:SetDisabled(false)
				SetStatus("Only the raid leader can start a raid.")
			end
		end
		if DEDKPSettings["RaidStarted"] and DraconisErus_Guild_IsOfficer(DERR_PLAYER) then
			DERR.MainWindow.BidManager:SetDisabled(false)
			DERR.MainWindow.LootManager:SetDisabled(false)
		end
	else
		DERR.MainWindow.ImportButton:SetDisabled(false)
		SetStatus("You are not in a raid.")
	end
end

function DEDKP_Filter_OnTextChanged(widget, event, msg)
	nameFilter = msg
	DEDKP_MainWindow_LoadGuild()
end

function DEDKP_Class_OnValueChanged(widget, event, key, checked)
	local className = dedkp_class_list[key]
	if checked then
		table.insert(classFilter,className)
	else
		local index = DraconisErus_TableSearch(classFilter,className)
		if index > 0 then table.remove(classFilter,index) end
	end
	DEDKP_MainWindow_LoadGuild()
end

function DEDKP_MainWindow_OnClose(widget)
	if DERR.MainWindow ~= nil then
		DraconisErus_SaveWindowPosition("MainWindow", widget)
		widget:ReleaseChildren()
		widget:Hide()
		DERR.MainWindow = nil
	end

end

AceGUI:RegisterLayout("DERR_Layout",
	function(content, children)
		local top = 0
		for i = 1, #children do
			local child = children[i]
			child.frame:SetPoint("TOP",content,"TOP",0,top)
			child.frame:Show()
			top = top - child.frame:GetHeight() - 5
		end
	end)

AceGUI:RegisterLayout("DERR_Center_Layout",
	function(content, children)
		local top = 0
		for i = 1, #children do
			local child = children[i]
			child.frame:SetPoint("CENTER",content,"CENTER",0,top)
			child.frame:Show()
			top = top - child.frame:GetHeight()
		end
	end)

